Bug 463272 - disk log mirror convert option is lost if down covert option is also given
disk log mirror convert option is lost if down covert option is also given
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: lvm2 (Show other bugs)
5.3
All Linux
medium Severity medium
: rc
: ---
Assigned To: Petr Rockai
Cluster QE
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-09-22 15:43 EDT by Corey Marthaler
Modified: 2010-03-30 05:01 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-03-30 05:01:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Corey Marthaler 2008-09-22 15:43:35 EDT
Description of problem:
If you attempt to down convert a mirror as well as convert it from core to disk log on the same cmd line, the disk log convert option will be dropped (not executed). However if you attempt to down convert a mirror as well as convert it from disk to core log on the same cmd line, it will work.

If you run the "half completed" cmd line that didn't do the disklog convert initially a second time, then it'll work since the down convert has already happened.

[root@grant-01 ~]# lvs -a -o +devices
  LV                VG         Attr   LSize  Origin Snap%  Move Log Copy%  Convert Devices                                                 
  mirror            grant      Mwi-a-  1.00G                        100.00         mirror_mimage_0(0),mirror_mimage_1(0),mirror_mimage_2(0)
  [mirror_mimage_0] grant      iwi-ao  1.00G                                       /dev/sdb1(0)                                            
  [mirror_mimage_1] grant      iwi-ao  1.00G                                       /dev/sdb2(0)                                            
  [mirror_mimage_2] grant      iwi-ao  1.00G                                       /dev/sdb3(0)                                            
[root@grant-01 ~]# lvconvert --mirrorlog disk -m 1 grant/mirror
  Logical volume mirror converted.
[root@grant-01 ~]# lvs -a -o +devices
  LV                VG         Attr   LSize  Origin Snap%  Move Log Copy%  Convert Devices                              
  mirror            grant      Mwi-a-  1.00G                         18.75         mirror_mimage_0(0),mirror_mimage_1(0)
  [mirror_mimage_0] grant      Iwi-ao  1.00G                                       /dev/sdb1(0)                         
  [mirror_mimage_1] grant      Iwi-ao  1.00G                                       /dev/sdb2(0)                         

## Note the above mirror still has an in-core log.

Version-Release number of selected component (if applicable):
2.6.18-116.el5

lvm2-2.02.40-2.el5    BUILT: Fri Sep 19 09:46:26 CDT 2008
lvm2-cluster-2.02.40-2.el5    BUILT: Fri Sep 19 09:49:59 CDT 2008
device-mapper-1.02.28-2.el5    BUILT: Fri Sep 19 02:50:32 CDT 2008
cmirror-1.1.25-1.el5    BUILT: Fri Sep 19 16:27:46 CDT 2008
kmod-cmirror-0.1.17-1.el5    BUILT: Fri Sep 19 16:27:33 CDT 200

How reproducible:
Everytime
Comment 1 Petr Rockai 2009-03-01 04:18:39 EST
I have looked into this and it shouldn't be hard to fix. Cf. 463274.
Comment 2 Petr Rockai 2009-05-20 16:32:51 EDT
Fix stalled upon review (and got out of date). Updated patch posted to lvm-devel@.
Comment 4 Petr Rockai 2009-08-02 17:59:43 EDT
Checked in upstream.
Comment 5 Milan Broz 2009-11-12 06:32:59 EST
Fix in lvm2-2_02_54-1_el5.
Comment 7 Corey Marthaler 2010-01-04 16:30:13 EST
Fix verified in lvm2-2.02.56-3.5.el5/lvm2-cluster-2.02.56-3.5.el5.

[root@taft-01 ~]# lvs -a -o +devices
  LV                VG         Attr   LSize   Log Copy%  Convert Devices
  mirror            taft       mwi-a- 100.00M     100.00         mirror_mimage_0(0),mirror_mimage_1(0),mirror_mimage_2(0)
  [mirror_mimage_0] taft       iwi-ao 100.00M                    /dev/sdb1(0)
  [mirror_mimage_1] taft       iwi-ao 100.00M                    /dev/sdc1(0)
  [mirror_mimage_2] taft       iwi-ao 100.00M                    /dev/sdd1(0)

[root@taft-01 ~]# lvconvert --mirrorlog disk -m 1 taft/mirror
  Logical volume mirror converted.

[root@taft-01 ~]# lvs -a -o +devices
  LV                VG         Attr   LSize   Log         Copy%  Convert Devices
  mirror            taft       mwi-a- 100.00M mirror_mlog  76.00         mirror_mimage_0(0),mirror_mimage_1(0)
  [mirror_mimage_0] taft       Iwi-ao 100.00M                           /dev/sdb1(0)
  [mirror_mimage_1] taft       Iwi-ao 100.00M                            /dev/sdc1(0)
  [mirror_mlog]     taft       lwi-ao   4.00M                            /dev/sdd1(25)
Comment 10 errata-xmlrpc 2010-03-30 05:01:50 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2010-0298.html

Note You need to log in before you can comment on or make changes to this bug.